.386
.model flat, stdcall
ExitProcess proto, ExitCode:dword

.data
  conjunto1  DB "ABC", 0
  conjunto2  DB "BM", 0
  resultado1 DW 5 DUP(0)
  conjunto3  DB "ACLMZ", 0
  resultado2 DW 5 DUP(0)

.code

; Proc para calcular la interseccion de 2 conjuntos
;
;	En la interesccion aparecen todos aquellos
;	elementos que pertenecian al segundo 
;	conjunto, siempre y cuando pertenecian
;	tambien al primer conjunto
;
intersec_conj proc
	push ebp
	mov ebp, esp
	
	push esi
	push edi
	push ebx
	push edx
	push eax
	
	; Recuperar parmetros e inicializar
	mov esi, [ebp + 16]	; Conjunto Origen 1
	mov edi, [ebp + 12]	; Conjunto Origen 2
	mov ebx, [ebp + 8]	; Conjunto Destino
	xor edx, edx		; Letra buscada

bucle_int:
	cmp [edi], byte ptr 0
	je acaba_int

	mov dl, [edi]
	push esi
	call pertenece
	cmp eax, 1
	jne sigue_int

	; El elemento est en ambos conjuntos
	inc ecx
	;--------------------------------------------hueco 1
	mov [ebx], dl
	;--------------------------------------------hueco 1
	inc ebx
	
sigue_int:
	inc edi
	jmp bucle_int

acaba_int:
	; Finalizar el conjunto (cadena)
	mov [ebx], byte ptr 0h
	
	; Restaurar registros y retornar
	pop eax
	pop edx
	pop ebx
	pop edi
	pop esi
	
	pop ebp
	ret 12
intersec_conj endp

; Proc para calcular la union de dos conjuntos:
;
;	En la union estan todos los elementos que
;	pertenecian al primer conjunto, ms todos
;	aquellos que pertenecian al segundo y no
;	pertenecian al primero
;
union_conj proc
	push ebp
	mov ebp, esp
	
	push esi
	push edi
	push ebx
	push edx
	push eax
	
	; Recuperar parametros e inicializacion
	mov esi, [ebp + 16]	; Conjunto Origen 1
	mov edi, [ebp + 12]	; Conjunto Origen 2
	mov ebx, [ebp + 8]	; Conjunto Destino
	xor edx, edx		; Letra buscada

copia:	
	cmp [esi], byte ptr 0
	je completa

	; El elemento pertenece al primer conjunto
	mov dl, [esi]
	;--------------------------------------------hueco 1
	mov [ebx], dl
	;--------------------------------------------hueco 1
	inc esi
	inc ebx
	jmp copia

completa: 
	; Se vuelve a recargar esi con la direccion
	; de comienzo del primer conjunto
	mov esi, [ebp + 16]
	
bucle_uni: 
	cmp [edi], byte ptr 0
	je acaba_uni

	mov dl, [edi]
	push esi
	call pertenece
	cmp eax, 0
	jne sigue_uni
	
	; Pertenecia al segundo y no al primero
	inc ecx
	;--------------------------------------------hueco 1
	mov [ebx], dl
	;--------------------------------------------hueco 1
	inc ebx
	
sigue_uni:
	inc edi
	jmp bucle_uni

acaba_uni:
	; Finalizar el conjunto (cadena)
	mov [ebx], byte ptr 0h
	
	; Restaurar registros y retornar
	pop eax
	pop edx
	pop ebx
	pop edi
	pop esi
	
	pop ebp
	ret 12
union_conj endp

pertenece PROC
	push ebp
	mov ebp, esp
	
	push esi
		
	mov esi, [ebp + 8]
	cmp [esi], byte ptr 0
	je no_encont
	
	cmp [esi], dl
	je encontrada
	
	inc esi
	push esi
	call pertenece
	jmp acaba_per

no_encont:
	mov eax, 0
	jmp acaba_per

encontrada:
	mov eax, 1

acaba_per:
	pop esi

	pop ebp
	;--------------------------------------------hueco 1
  ret 4
	;--------------------------------------------hueco 1
pertenece ENDP

inicio: 
	xor ecx, ecx

	; Paso de parametros y llamada a union
	push offset conjunto1
	push offset conjunto2
	push offset resultado1
	call union_conj	
	
	; Paso de parametros y llamada a inter
	push offset resultado1
	push offset conjunto3
	push offset resultado2
	call intersec_conj

	; Retorno al S.O.
	push 0
	call ExitProcess
END inicio
