.386
.model flat, stdcall
ExitProcess proto, ExitCode:dword

.data
  ImagenReferencia  db 65536 dup (0)
  ImagenSegmentada  db 65536 dup (0)

  Ntp DD 0
  Nfp DD 0
  Ntn DD 0
  Nfn DD 0
  
  Jaccard real4 0.0 
.code

CompararImagenesBinarias proc
  push ebp
  mov ebp, esp
  
  ; Hacer hueco para 4 variables locales 
  ; de tipo DD (4 * 4) = 16
  sub esp, 16
 
  ; Variables locales es almacenar:
  ; Ntp: [ebp - 4]
  ; Nfp: [ebp - 8]
  ; Ntn: [ebp - 12]
  ; Nfn: [ebp - 16]

  mov [ebp - 4], dword ptr 0
  mov [ebp - 8], dword ptr 0
  mov [ebp - 12], dword ptr 0
  mov [ebp - 16], dword ptr 0
  
  push esi
  push edi
  
  ; Imagen de referencia
  mov esi, [ebp + 8]	
  
  ; Imagen segmentada
  mov edi, [ebp + 12]	

  ; Nmero de pxeles de las imagenes
  mov ecx, [ebp + 16]	
 
  ; ndice
  xor edx, edx
  
Bucle:
  mov al, [esi + edx]
  cmp al, [edi + edx]
  je Iguales

  cmp al, 0
  je Distintos_ref_0
  
  ; distintos ref = 1, seg = 0 (inc Nfn)
  inc dword ptr [ebp - 16]

  jmp SiguientePixel
  
Distintos_ref_0:
  ; distintos ref = 0, seg = 1 (inc Nfp)
  inc dword ptr [ebp - 8]
  
  jmp SiguientePixel
  
Iguales:
  cmp al, 1
  je Iguales_a_1
  
  ; iguales a 0 (inc Ntn)
  inc dword ptr [ebp - 12]
  
  jmp SiguientePixel
  
Iguales_a_1:
  ; iguales a 1 (inc Ntp)
  inc dword ptr [ebp - 4]

SiguientePixel:
  inc edx
  loop Bucle
  
  mov eax, [ebp - 4]
  mov ebx, [ebp - 8]
  mov ecx, [ebp - 12]
  mov edx, [ebp - 16]

  pop edi
  pop esi
	
  mov esp, ebp
  pop ebp
  ret 12
CompararImagenesBinarias endp	

CalcularJaccard proc
  push ebp
  mov ebp, esp

  push eax

  ; Ntp -> [ebp + 20]
  ; Nfp -> [ebp + 16]
  ; Nfn -> [ebp + 12]
  ; offset Jaccard -> [ebp + 8]
  
  ; eax = Ntp
  mov eax, [ebp + 20]
  
  ; Si Ntp vale cero, Jaccard vale 0
  ; Adems se evita la posible div entre 0
  cmp eax, 0
  jne SigueJaccard
  
  mov eax, [ebp + 8]
  mov [eax], real4 ptr 0
  jmp FinJaccard
  
SigueJaccard:

  ; eax = Ntp + Nfp
  add eax, [ebp + 16]

  ; eax = Ntp + Nfp + Nfn
  add eax, [ebp + 12]
  
  ; Dividendo
  fild dword ptr [ebp + 20]
  
  ; Divisor
  push eax
  fild dword ptr [esp]
  pop eax
  
  fdiv

  ; Se obtiene el resultado
  mov eax, [ebp + 8]
  fstp real4 ptr [eax]

FinJaccard:  
  pop eax
  pop ebp
  ret 16
CalcularJaccard endp	

LeerImagenes proc
  push ebp
  mov ebp, esp

  push esi
  push edi
  push ecx
  
  ; Imagen de referencia
  mov esi, [ebp + 8]	
  
  ; Imagen segmentada
  mov edi, [ebp + 12]	

  ; Nmero de pxeles de las imagenes
  mov ecx, [ebp + 16]	
  
BucleInicializar:
  mov [esi], byte ptr 0
  mov [edi], byte ptr 0
  inc esi
  inc edi
  loop BucleInicializar
  
  mov ecx, 100	
  mov esi, [ebp + 8]	
BucleInicializarRef:
  mov [esi], byte ptr 1
  inc esi
  loop BucleInicializarRef

  mov ecx, 200	
  mov edi, [ebp + 12]	
  add edi, 50
BucleInicializarSeg:
  mov [edi], byte ptr 1
  inc edi
  loop BucleInicializarSeg

  pop ecx
  pop edi
  pop esi
  pop ebp
  ret 12
LeerImagenes endp	

Inicio:
  push 65536
  push offset ImagenSegmentada
  push offset ImagenReferencia
  call LeerImagenes

  push 65536
  push offset ImagenSegmentada
  push offset ImagenReferencia
  call CompararImagenesBinarias
  
  mov [Ntp], eax
  mov [Nfp], ebx
  mov [Ntn], ecx
  mov [Nfn], edx

  push [Ntp]
  push [Nfp]
  push [Nfn]
  push offset Jaccard
  call CalcularJaccard

  push 1
  push 1
  push 0
  push offset Jaccard
  call CalcularJaccard
  
  push 0
  call ExitProcess
end Inicio